;#########################################################################
;#                    Screen-Maker by David Vogel                        #
;#                     www.Wave-Design.Rshost.de                         #
;#########################################################################

UseJPEGImageEncoder()
UsePNGImageEncoder()

; ####################################### Variablen #####################################

Global Capture_Time.l

Structure Window_Main
  ID.l
  Button.l [3]
  Text.l [8]
  Frame3D.l [4]
  String.l [3]
  TrackBar.l [1]
  CheckBox.l [1]
  ListView.l [1]
EndStructure
Global Window_Main.Window_Main

Structure Einstellungen
  Resize.l
  Resize_X.l
  Resize_Y.l
  Desktop_X.l
  Desktop_Y.l
  Format.l ; 0 = Jpg 1 = png 2 = Bmp
  Quality.l
  Capture.l
  Ort.s
  Time.l
EndStructure
Global Einstellungen.Einstellungen

; ####################################### Proceduren #######################################

Procedure Open_Window_Main()
  Window_Main\ID = OpenWindow(#PB_Any, 0, 0, 260, 380, "Screen-Maker  David Vogel",  #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered )
  If Window_Main\ID
    If CreateGadgetList(WindowID(Window_Main\ID))
      Window_Main\Button [0] = ButtonGadget(#PB_Any, 10, 300, 120, 60, "Start")
      DisableGadget(Window_Main\Button [0], 1)
      Window_Main\Button [1] = ButtonGadget(#PB_Any, 130, 300, 120, 60, "Stop")
      DisableGadget(Window_Main\Button [1], 1)
      Window_Main\Button [2] = ButtonGadget(#PB_Any, 10, 20, 70, 20, "Ort Whlen")
      Window_Main\Text [0] = TextGadget(#PB_Any, 10, 40, 240, 40, "")
      SetGadgetText(Window_Main\Text [0], Einstellungen\Ort)
      Window_Main\Frame3D [0] = Frame3DGadget(#PB_Any, 0, 0, 260, 90, "Ort")
      Window_Main\Listview [0] = ListViewGadget(#PB_Any, 10, 110, 100, 70)
      AddGadgetItem(Window_Main\Listview [0], 0, "Jpeg")
      AddGadgetItem(Window_Main\Listview [0], 1, "Png")
      AddGadgetItem(Window_Main\Listview [0], 2, "Bmp")
      Window_Main\Frame3D [1] = Frame3DGadget(#PB_Any, 0, 90, 260, 100, "Bildformat und Qualitt")
      Window_Main\TrackBar [0] = TrackBarGadget(#PB_Any, 120, 110, 130, 20, 0, 10, #PB_TrackBar_Ticks)
      DisableGadget(Window_Main\TrackBar [0], 1)
      Window_Main\Text [1] = TextGadget(#PB_Any, 120, 130, 130, 20, "0", #PB_Text_Center)
      Window_Main\Frame3D [2] = Frame3DGadget(#PB_Any, 0, 190, 260, 50, "Skalieren")
      Window_Main\CheckBox [0] = CheckBoxGadget(#PB_Any, 10, 210, 40, 20, "Ja")
      Window_Main\String [0] = StringGadget(#PB_Any, 70, 210, 70, 20, Str(Einstellungen\Resize_X))
      DisableGadget(Window_Main\String [0], 1)
      Window_Main\String [1] = StringGadget(#PB_Any, 170, 210, 70, 20, Str(Einstellungen\Resize_Y))
      DisableGadget(Window_Main\String [1], 1)
      Window_Main\Text [2] = TextGadget(#PB_Any, 150, 210, 20, 20, "Y:", #PB_Text_Right)
      Window_Main\Text [3] = TextGadget(#PB_Any, 50, 210, 20, 20, "X:", #PB_Text_Right)
      Window_Main\Text [4] = TextGadget(#PB_Any, 120, 150, 130, 30, "Kein Format ausgewhlt!")
      Window_Main\Text [5] = TextGadget(#PB_Any, 10, 360, 240, 20, "Bildschirmaufnahme gestoppt", #PB_Text_Center)
      Window_Main\Frame3D [3] = Frame3DGadget(#PB_Any, 0, 240, 260, 50, "Zeit")
      Window_Main\String [2] = StringGadget(#PB_Any, 120, 260, 60, 20, "300")
      Window_Main\Text [6] = TextGadget(#PB_Any, 10, 260, 100, 20, "Zeit in Sekunden:", #PB_Text_Right)
      Window_Main\Text [7] = TextGadget(#PB_Any, 190, 260, 60, 20, "= 5min")
    EndIf
  EndIf
EndProcedure

Procedure MakeDesktopScreenshot(Width, Height, Format, Quality)
  ExamineDesktops()
  hImage = CreateImage(#PB_Any,DesktopWidth(0),DesktopHeight(0)) 
  DeskDC = GetDC_(GetDesktopWindow_())
  hDC    = StartDrawing(ImageOutput(hImage))
  BitBlt_(hDC,0,0,DesktopWidth(0),DesktopHeight(0),DeskDC,0,0,#SRCCOPY)
  StopDrawing()
  ResizeImage(hImage, Width, Height)
  Select Format
    Case 0
      SaveImage(hImage,Einstellungen\Ort+FormatDate("%yyyy.%mm.%dd  %hh_%ii_%ss", Date())+".jpg",#PB_ImagePlugin_JPEG,quality)
    Case 1
      SaveImage(hImage,Einstellungen\Ort+FormatDate("%yyyy.%mm.%dd  %hh_%ii_%ss", Date())+".png",#PB_ImagePlugin_PNG)
    Case 2
      SaveImage(hImage,Einstellungen\Ort+FormatDate("%yyyy.%mm.%dd  %hh_%ii_%ss", Date())+".bmp")
  EndSelect
  FreeImage(hImage)
EndProcedure

; ########################################## Init ######################################

ExamineDesktops()
Einstellungen\Desktop_X = DesktopWidth(0)
Einstellungen\Desktop_Y = DesktopHeight(0)
Einstellungen\Resize_X = Einstellungen\Desktop_X
Einstellungen\Resize_Y = Einstellungen\Desktop_Y
Open_Window_Main()

; ########################################## Hauptschleife #######################################

Repeat
  Event = WaitWindowEvent(10)
  If Event = #PB_Event_Gadget
    Select EventGadget()
      Case Window_Main\Button [2]
        Einstellungen\Ort.s = PathRequester("Whlen sie den Ort fr die Screenshots", "")
        SetGadgetText(Window_Main\Text [0], Einstellungen\Ort)
        
      Case Window_Main\Button [0]
        Einstellungen\Capture = 1
        SetGadgetText(Window_Main\Text [5], "Bildschirmaufnahme gestartet")
        Capture_Time = ElapsedMilliseconds()+ Einstellungen\Time
        DisableGadget(Window_Main\Listview [0], 1)
        DisableGadget(Window_Main\Listview [0], 1)
        DisableGadget(Window_Main\Button [0], 1)
        DisableGadget(Window_Main\Button [1], 0)
      
      Case Window_Main\Button [1]
        Einstellungen\Capture = 0
        SetGadgetText(Window_Main\Text [5], "Bildschirmaufnahme gestoppt")
        DisableGadget(Window_Main\Listview [0], 0)
        DisableGadget(Window_Main\Button [0], 0)
        DisableGadget(Window_Main\Button [1], 1)
        
      Case Window_Main\String [2]
        Einstellungen\Time = Val(GetGadgetText(Window_Main\String [2]))
        SetGadgetText(Window_Main\Text [7], "= "+Str(Einstellungen\Time/60)+"min")
        
      Case Window_Main\Listview [0]
        Einstellungen\Format = GetGadgetState(Window_Main\Listview [0])
        If Einstellungen\Ort <> ""
          Select Einstellungen\Format
            Case -1
              DisableGadget(Window_Main\Button [0], 1)
              DisableGadget(Window_Main\TrackBar [0], 1)
              SetGadgetText(Window_Main\Text [4], "Kein Format ausgewhlt!")
            
            Case 0
              DisableGadget(Window_Main\Button [0], 0)
              DisableGadget(Window_Main\TrackBar [0], 0)
              SetGadgetText(Window_Main\Text [4], "Jpeg, am kleinsten aber verlustbehaftet")
              Einstellungen\Quality = 10
              SetGadgetText(Window_Main\Text [1], Str(Einstellungen\Quality))
              SetGadgetState(Window_Main\TrackBar [0], 10)
              
            Case 1
              DisableGadget(Window_Main\Button [0], 0)
              DisableGadget(Window_Main\TrackBar [0], 1)
              SetGadgetText(Window_Main\Text [4], "Png, klein und verlustfrei")
              SetGadgetText(Window_Main\Text [1], "-")
              
            Case 2
              DisableGadget(Window_Main\Button [0], 0)
              DisableGadget(Window_Main\TrackBar [0], 1)
              SetGadgetText(Window_Main\Text [4], "Bmp, sehr gro und verlustfrei")
              SetGadgetText(Window_Main\Text [1], "-")
              
          EndSelect
        EndIf
        
      Case Window_Main\TrackBar [0]
        Einstellungen\Quality = GetGadgetState(Window_Main\TrackBar [0])
        SetGadgetText(Window_Main\Text [1], Str(Einstellungen\Quality))
        
      Case Window_Main\CheckBox [0]
        If GetGadgetState(Window_Main\CheckBox [0]) = 1
          Einstellungen\Resize = 1
          DisableGadget(Window_Main\String [0], 0)
          DisableGadget(Window_Main\String [1], 0)
        Else
          Einstellungen\Resize = 0
          DisableGadget(Window_Main\String [0], 1)
          DisableGadget(Window_Main\String [1], 1)
        EndIf
      
      Case Window_Main\String [0]
        Einstellungen\Resize_X = Val(GetGadgetText(Window_Main\String [0]))
      
      Case Window_Main\String [1]
        Einstellungen\Resize_Y = Val(GetGadgetText(Window_Main\String [1]))
        
    EndSelect
  EndIf
  If Einstellungen\Capture = 1 And Capture_Time < ElapsedMilliseconds() And Einstellungen\Time <> 0
    Capture_Time + Einstellungen\Time*1000
    If Einstellungen\Resize = 1
      MakeDesktopScreenshot(Einstellungen\Resize_X, Einstellungen\Resize_Y, Einstellungen\Format, Einstellungen\Quality)
    Else
      MakeDesktopScreenshot(Einstellungen\Desktop_X, Einstellungen\Desktop_Y, Einstellungen\Format, Einstellungen\Quality)
    EndIf
  EndIf
Until Event = #PB_Event_CloseWindow
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 3
; FirstLine = 150
; Folding = -
; EnableXP
; DisableDebugger